{
******************************************************************************
*
*        
*     .
*      ,    .
*
*****************************************************************************
}

unit CMLGeneral;

interface

uses
  Windows;

const
  CML_LIBS_VERSION                  = 2;
  CML_LAST_SUPPORTED_CLIENT_VERSION = 1;

{  .   !!! }

  OPERATION_SUCCESFUL    = 0;
  ERROR_NOTIMPLEMENTED   = DWORD(-1);
  ERROR_INDEXOUTOFBOUNDS = DWORD(-2);

  CTL_NONE = $0;
  CTL_I    = $1;
  CTL_U    = $2;
  CTL_P    = $4;

{    ! ..        }
  FLAG_LAMP_HEATING               = $00000001; //  
  FLAG_YEARPLAN                   = $00000002; //   
  FLAG_ASUDD_KS                   = $00000004; //     -
  FLAG_CASCADE_SUPPURT            = $00000008; //  
  FLAG_SEASON_TIME                = $00000010; //        
  FLAG_SAVE_BIT_DU                = $00000020; //   "   "
  FLAG_ASSUD_FILTER_OFF           = $00000040; //   "  "
  FLAG_CALC_TPROM                 = $00000080; //   
  FLAG_SPECPHASES                 = $00000100; //  
  FLAG_SPECIAL_DAYS               = $00000200; //    ()
  FLAG_ALL_YEALLOW_BEFORE_BLINK   = $00000400; //   "  3  "
  FLAG_RELATIVE_TIME              = $00000800; //     .
  FLAG_ASSUD_OMSK                 = $00001000; //     C- ()
  FLAG_EXPAND_YEAR_PLAN           = $00002000; //    
  FLAG_EXPAND_YEAR_PLAN_WITH_CALL = $00004000; //      
  FLAG_ADAPTIVE_CONTROL           = $00008000; //   
  FLAG_ASUDD_KOMKON               = $00010000; //      ()

{       }
  // -1 . (16 .)
  MODEL_REVISION_KDU_1F   = 5;
  INTERNAL_ID_KDU_1F      = 4;

  // -1 . (16 .)
  MODEL_REVISION_KDU_1MF  = 4;
  INTERNAL_ID_KDU_1MF     = 3;

  // -3.1 (16 .)
  MODEL_REVISION_KDU_3_1  = 1;
  INTERNAL_ID_KDU_3_1     = 12;

  // -3.2 (24 .)
  MODEL_REVISION_KDU_3_2  = 3;
  INTERNAL_ID_KDU_3_2     = 13;

  // -3.3 (32 .)
  MODEL_REVISION_KDU_3_3  = 2;
  INTERNAL_ID_KDU_3_3     = 14;

  // -3.1 (16 .)
  MODEL_REVISION_KDU_3_1M = 1;
  INTERNAL_ID_KDU_3_1M    = 0;

  // -3.2 (24 .)
  MODEL_REVISION_KDU_3_2M = 3;
  INTERNAL_ID_KDU_3_2M    = 1;

  // -3.3 (32 .)
  MODEL_REVISION_KDU_3_3M = 2;
  INTERNAL_ID_KDU_3_3M    = 2;

  // -3.2 (24 .)
  MODEL_REVISION_KDU_3_2N = 7;
  INTERNAL_ID_KDU_3_2N    = 7;

  // -3.2. (24 .)
  MODEL_REVISION_KDU_3_2N1 = 15;
  INTERNAL_ID_KDU_3_2N1    = 19;

  // -3.3 (32 .)
  MODEL_REVISION_KDU_3_3N = 8;
  INTERNAL_ID_KDU_3_3N    = 8;

  // -3.6 (32 .)
  INTERNAL_ID_KDU_3_6N    = 20;

  // -3.4 (48 .)
  INTERNAL_ID_KDU_3_4N    = 18;

  // -3.3 (32 .)
  MODEL_REVISION_KDU_3_3S = 6;
  INTERNAL_ID_KDU_3_3S    = 5;

  // -3.1 (16 .)
  MODEL_REVISION_KDU_3_1S = 12;
  INTERNAL_ID_KDU_3_1S    = 17;

  // -4.1 (16 .)
  MODEL_REVISION_KDU_4_1  = 9;
  INTERNAL_ID_KDU_4_1     = 9;

  // -3
  MODEL_REVISION_KDU_3NV    = 10;
  {INTERNAL_ID_KDU_3NV       = 10;}
    INTERNAL_ID_KDM_1       = 10;

  // -1 (12 .)
  MODEL_REVISION_PSA_1    = 11;
  INTERNAL_ID_PSA_1       = 11;

  // -1 (32 .  )
  MODEL_REVISION_KDA_1    = 13;
  INTERNAL_ID_KDA_1       = 15;

  // -2 (32 .  )
  MODEL_REVISION_KDA_2    = 14;
  INTERNAL_ID_KDA_2       = 16;

{   }
  FAMILY_KDU_1F  = 1; // -1 .:  -1 . (16 ), -1 . (16 )
  FAMILY_KDU_3   = 2; // -3:         -3.1 (16 ), -3.2 (24 ), -3.3 (32 )
  FAMILY_KDU_3M  = 3; // -3M:        -3.1 (16 ), -3.2 (24 ), -3.3 (32 )
  FAMILY_KDU_3N  = 4; // -3:        -3.2 (24 ), -3.3 (32 )
  FAMILY_KDU_3S  = 5; // -3:        -3.3 (32 ), -3.2
  FAMILY_KDU_4   = 6; // -4:         -4.1 (16 )
  //FAMILY_KDM     = 7; // -1 ->> 9
  FAMILY_PSA     = 8; // -1
  FAMILY_KDA     = 9; // -1, -1, -2
  FAMILY_KDU_3N1  = 10; // -3.:        -3.2. (24 ), -3.3. (32 )
  FAMILY_KDU_3NV = 11; // -3.:        -3.2. (24 ), -3.3. (32 )

  FAMILY_KDU_1F_TITLE  = '-1 .';
  FAMILY_KDU_3_TITLE   = '-3';
  FAMILY_KDU_3M_TITLE  = '-3M';
  FAMILY_KDU_3N_TITLE  = '-3';
  FAMILY_KDU_3N1_TITLE  = '-3.';
  FAMILY_KDU_3NV_TITLE  = '-3';
  FAMILY_KDU_3S_TITLE  = '-3';
  FAMILY_KDU_4_TITLE   = '-4';
  //FAMILY_KDM_TITLE     = '-1'; - removed
  FAMILY_PSA_TITLE     = '-1';
  FAMILY_KDA_TITLE     = '';


implementation

end.
