{
********************************************************************************
*
*      .
*       .
*
********************************************************************************
}
unit CMLimpl;

interface

uses
  Windows, CMLGeneral;

//    
function GetCMLVersion: DWORD; stdcall; export;

//    
function GetLastClientVersion: DWORD; stdcall; export;

//   -       
function GetDescriptionA: pchar; stdcall; export;

//  ,    
function GetInternalID: DWORD; stdcall; export;

//  ,    
function GetRevision: byte; stdcall; export;

//   
function GetFamily: byte; stdcall; export;

//  
function GetFamilyNameA: pchar; stdcall; export;

//    , 
function GetMaxRAMSize: DWORD; stdcall; export;

//   -    FLAG_XXXX
function GetFlags: DWORD; stdcall; export;

// -   (   )
function GetInputCount: byte; stdcall; export;

// -  
function GetOutputCount: byte; stdcall; export;

//       
function GetOutputDescriptionA(index: DWORD; var Ret: pchar): DWORD; stdcall; export;
{
    ,    Ret     
   0,   ERROR_NOTIMPLEMENTED
}

//    
function GetOutputMask(index: DWORD; var Ret: DWORD): DWORD; stdcall; export;
{
    ,     Ret    0,
    ERROR_NOTIMPLEMENTED
}

//    .  
function GetOutputCtlOptions(index: DWORD; var Ret: DWORD): DWORD; stdcall; export;
{
    ,     Ret   CTL_XXXX   0,
    ERROR_NOTIMPLEMENTED
}

//       (  )
function GetMaxDayplanItemsCount: DWORD; stdcall; export;

//       (  )
function GetMaxYearplanItemsCount: DWORD; stdcall; export;

//     (  )
function GetMaxWorkCyclesCount: DWORD; stdcall; export;

implementation

resourcestring
  MODEL_DESCRIPTION = '-3.2.';

  OUTPUT_R1 = '1';  OUTPUT_A1 = '1';  OUTPUT_G1 = '1';
  OUTPUT_R2 = '2';  OUTPUT_A2 = '2';  OUTPUT_G2 = '2';
  OUTPUT_R3 = '3';  OUTPUT_A3 = '3';  OUTPUT_G3 = '3';
  OUTPUT_R4 = '4';  OUTPUT_A4 = '4';  OUTPUT_G4 = '4';
  OUTPUT_R5 = '5';  OUTPUT_A5 = '5';  OUTPUT_G5 = '5';
  OUTPUT_R6 = '6';  OUTPUT_A6 = '6';  OUTPUT_G6 = '6';
  OUTPUT_R7 = '7';  OUTPUT_A7 = '7';  OUTPUT_G7 = '7';
  OUTPUT_R8 = '8';  OUTPUT_A8 = '8';  OUTPUT_G8 = '8';

const
  MODEL_INTERNAL_ID        = INTERNAL_ID_KDU_3_2N1;
  MODEL_REVISION           = MODEL_REVISION_KDU_3_2N1;
  MODEL_FAMILY             = FAMILY_KDU_3N1;
  MODEL_FAMILY_NAME        = FAMILY_KDU_3N1_TITLE;
  MODEL_OUTPUTCOUNT        = 24;
  MODEL_INPUTCOUNT         = 2;
  RAM_SIZE_LIMIT           = 2048;
  MAX_DAYPLAN_ITEMS_COUNT  = 84;
  MAX_YEARPLAN_ITEMS_COUNT = 63;
  MAX_WORK_CYCLES_COUNT    = 232;

  //  
  SUPPORTED_FLAGS: DWORD =
    FLAG_LAMP_HEATING
    or FLAG_YEARPLAN
    or FLAG_ASUDD_KS
    or FLAG_ASSUD_OMSK
    or FLAG_CASCADE_SUPPURT
    or FLAG_SEASON_TIME
    or FLAG_SAVE_BIT_DU
    or FLAG_ASSUD_FILTER_OFF
    or FLAG_CALC_TPROM
    or FLAG_SPECPHASES
//    or FLAG_SPECIAL_DAYS
//    or FLAG_ALL_YEALLOW_BEFORE_BLINK
    or FLAG_RELATIVE_TIME
    or FLAG_EXPAND_YEAR_PLAN
//    or FLAG_EXPAND_YEAR_PLAN_WITH_CALL
    or FLAG_ADAPTIVE_CONTROL
  ;

  OUTPUT_ARRAY: array[0..MODEL_OUTPUTCOUNT-1] of string = (
    OUTPUT_R1,    OUTPUT_A1,    OUTPUT_G1,
    OUTPUT_R2,    OUTPUT_A2,    OUTPUT_G2,
    OUTPUT_R3,    OUTPUT_A3,    OUTPUT_G3,
    OUTPUT_R4,    OUTPUT_A4,    OUTPUT_G4,
    OUTPUT_R5,    OUTPUT_A5,    OUTPUT_G5,
    OUTPUT_R6,    OUTPUT_A6,    OUTPUT_G6,
    OUTPUT_R7,    OUTPUT_A7,    OUTPUT_G7,
    OUTPUT_R8,    OUTPUT_A8,    OUTPUT_G8
  );

  OUTPUT_MASKARRAY:  array[0..MODEL_OUTPUTCOUNT-1] of DWORD = (
    $00000001,    $00000002,    $00000004,
    $00000008,    $00000010,    $00000020,
    $00000040,    $00000080,    $00000100,
    $00000200,    $00000400,    $00000800,
    $00001000,    $00002000,    $00004000,
    $00008000,    $00010000,    $00020000,
    $00040000,    $00080000,    $00100000,
    $00200000,    $00400000,    $00800000
  );

  OUTPUT_CTLARRAY:  array[0..MODEL_OUTPUTCOUNT-1] of DWORD = (
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U,
    CTL_I,    CTL_NONE,    CTL_U
  );

function GetCMLVersion: DWORD; stdcall;
begin
  Result := CML_LIBS_VERSION;
end;

function GetLastClientVersion: DWORD; stdcall;
begin
  Result := CML_LAST_SUPPORTED_CLIENT_VERSION;
end;

function GetDescriptionA: pchar; stdcall;
begin
  Result := pchar(string(MODEL_DESCRIPTION));
end;

function GetInternalID: DWORD; stdcall;
begin
  Result := MODEL_INTERNAL_ID;
end;

function GetRevision: byte; stdcall;
begin
  Result := MODEL_REVISION;
end;

function GetFamily: byte; stdcall;
begin
  Result := MODEL_FAMILY;
end;

function GetFamilyNameA: pchar; stdcall;
begin
  Result := pchar(string(MODEL_FAMILY_NAME));
end;

function GetFlags: DWORD; stdcall;
begin
  Result := SUPPORTED_FLAGS;
end;

function GetOutputCount: byte; stdcall;
begin
  Result := MODEL_OUTPUTCOUNT;
end;

function GetInputCount: byte; stdcall;
begin
  Result := MODEL_INPUTCOUNT;
end;

function GetMaxRAMSize: DWORD; stdcall;
begin
  Result := RAM_SIZE_LIMIT;
end;

function GetOutputDescriptionA(index: DWORD; var Ret: pchar): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := pchar(OUTPUT_ARRAY[index]);
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetOutputMask(index: DWORD; var Ret: DWORD): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := OUTPUT_MASKARRAY[index];
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetOutputCtlOptions(index: DWORD; var Ret: DWORD): DWORD; stdcall;
begin
  if index < MODEL_OUTPUTCOUNT then
  begin
    Ret := OUTPUT_CTLARRAY[index];
    Result := OPERATION_SUCCESFUL;
  end
  else begin
    Result := ERROR_NOTIMPLEMENTED;
    SetLastError(ERROR_INDEXOUTOFBOUNDS);
  end;
end;

function GetMaxDayplanItemsCount: DWORD; stdcall;
begin
  Result := MAX_DAYPLAN_ITEMS_COUNT;
end;

function GetMaxYearplanItemsCount: DWORD; stdcall;
begin
  Result := MAX_YEARPLAN_ITEMS_COUNT;
end;

function GetMaxWorkCyclesCount: DWORD; stdcall;
begin
  Result := MAX_WORK_CYCLES_COUNT;
end;

end.
